# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
import os
import sys

basedir = os.path.abspath(os.path.join(os.path.dirname(__file__), "..", ".."))
source = os.path.abspath(os.path.join(os.path.dirname(__file__), "..", "..", "src"))

sys.path.insert(0, source)
sys.path.insert(0, basedir)


# -- Project information -----------------------------------------------------

project = 'GroPro'
copyright = '2021, Roman Romany'
author = 'Roman Romany -- IEK-8 -- Forschungszentrum Jülich GmbH'

# The short X.Y version
version = ''
# The full version, including alpha/beta/rc tags
release = ''

# -- General configuration ---------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    'sphinx.ext.autodoc',
    'sphinx.ext.coverage',
    'sphinx.ext.imgmath',
    'sphinx.ext.viewcode',
    'sphinx.ext.napoleon',
    'sphinx.ext.autosectionlabel',
    'sphinx.ext.inheritance_diagram',
        ]

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

master_doc = 'index'

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = 'de'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = ['.build', 'Thumbs.db', '.DS_Store']

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'sphinx'

# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = 'sphinxdoc'

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

# Output file base name for HTML help builder.
htmlhelp_basename = 'GroProdoc'


# -- Options for LaTeX output ------------------------------------------------

latex_engine = 'pdflatex'
# latex_elements = {
    # # The paper size ('letterpaper' or 'a4paper').
    # #
    # 'papersize': 'a4paper',
    # 'releasename':" ",
    # # Sonny, Lenny, Glenn, Conny, Rejne, Bjarne and Bjornstrup
    # # 'fncychap': '\\usepackage[Lenny]{fncychap}',
    # 'fncychap': '\\usepackage{fncychap}',
    # 'fontpkg': '\\usepackage{amsmath,amsfonts,amssymb,amsthm}',

    # 'figure_align':'htbp',
    # # The font size ('10pt', '11pt' or '12pt').
    # #
    # 'pointsize': '10pt',

    # # Additional stuff for the LaTeX preamble.
    # #
    # 'preamble': r'''
        # %%%%%%%%%%%%%%%%%%%% Meher %%%%%%%%%%%%%%%%%%
        # %%%add number to subsubsection 2=subsection, 3=subsubsection
        # %%% below subsubsection is not good idea.
        # \setcounter{secnumdepth}{3}
        # %
        # %%%% Table of content upto 2=subsection, 3=subsubsection
        # \setcounter{tocdepth}{2}

        # \usepackage{amsmath,amsfonts,amssymb,amsthm}
        # \usepackage{graphicx}

        # %%% reduce spaces for Table of contents, figures and tables
        # %%% it is used "\addtocontents{toc}{\vskip -1.2cm}" etc. in the document
        # \usepackage[notlot,nottoc,notlof]{}

        # \usepackage{color}
        # \usepackage{transparent}
        # \usepackage{eso-pic}
        # \usepackage{listings}
        # \lstset{
            # language=Python,                 % the language of the code
            # title=\lstname                   % show the filename of files included with \lstinputlisting; also try caption instead of title
        # }

        # \usepackage{footnotebackref} %%link at the footnote to go to the place of footnote in the text

        # %% spacing between line
        # \usepackage{setspace}
        # %%%%\onehalfspacing
        # %%%%\doublespacing
        # \singlespacing


        # %%%%%%%%%%% datetime
        # \usepackage{datetime}

        # \newdateformat{MonthYearFormat}{%
            # \monthname[\THEMONTH], \THEYEAR}


        # %% RO, LE will not work for 'oneside' layout.
        # %% Change oneside to twoside in document class
        # \usepackage{fancyhdr}
        # \pagestyle{fancy}
        # \fancyhf{}

        # %%% Alternating Header for oneside
        # \fancyhead[L]{\ifthenelse{\isodd{\value{page}}}{ \small \nouppercase{\leftmark} }{}}
        # \fancyhead[R]{\ifthenelse{\isodd{\value{page}}}{}{ \small \nouppercase{\rightmark} }}

        # %%% Alternating Header for two side
        # %\fancyhead[RO]{\small \nouppercase{\rightmark}}
        # %\fancyhead[LE]{\small \nouppercase{\leftmark}}

        # %% for oneside: change footer at right side. If you want to use Left and right then use same as header defined above.
        # \fancyfoot[R]{\ifthenelse{\isodd{\value{page}}}{{\tiny Meher Krishna Patel} }{\href{http://pythondsp.readthedocs.io/en/latest/pythondsp/toc.html}{\tiny PythonDSP}}}

        # %%% Alternating Footer for two side
        # %\fancyfoot[RO, RE]{\scriptsize Meher Krishna Patel (mekrip@gmail.com)}

        # %%% page number
        # \fancyfoot[CO, CE]{\thepage}

        # \renewcommand{\headrulewidth}{0.5pt}
        # \renewcommand{\footrulewidth}{0.5pt}

        # \RequirePackage{tocbibind} %%% comment this to remove page number for following
        # \addto\captionsenglish{\renewcommand{\contentsname}{Table of contents}}
        # \addto\captionsenglish{\renewcommand{\listfigurename}{List of figures}}
        # \addto\captionsenglish{\renewcommand{\listtablename}{List of tables}}
        # % \addto\captionsenglish{\renewcommand{\chaptername}{Chapter}}


        # %%reduce spacing for itemize
        # \usepackage{enumitem}
        # \setlist{nosep}

        # %%%%%%%%%%% Quote Styles at the top of chapter
        # \usepackage{epigraph}
        # \setlength{\epigraphwidth}{0.8\columnwidth}
        # \newcommand{\chapterquote}[2]{\epigraphhead[60]{\epigraph{\textit{#1}}{\textbf {\textit{--#2}}}}}
        # %%%%%%%%%%% Quote for all places except Chapter
        # \newcommand{\sectionquote}[2]{{\quote{\textit{``#1''}}{\textbf {\textit{--#2}}}}}
    # ''',


    # # Latex figure (float) alignment
    # #
    # # 'figure_align': 'htbp',
    # 'sphinxsetup': \
        # 'hmargin={0.7in,0.7in}, vmargin={1in,1in}, \
        # verbatimwithframe=true, \
        # TitleColor={rgb}{0,0,0}, \
        # HeaderFamily=\\rmfamily\\bfseries, \
        # InnerLinkColor={rgb}{0,0,1}, \
        # OuterLinkColor={rgb}{0,0,1}',

        # 'tableofcontents':' ',



# }

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').

    # 'papersize': 'letterpaper',

    # The font size ('10pt', '11pt' or '12pt').

    # 'pointsize': '10pt',

    # Additional stuff for the LaTeX preamble.

    'preamble': '\\usepackage{struktex}',

    # Latex figure (float) alignment

    # 'figure_align': 'htbp',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (master_doc, 'Dokumentation.tex', 'Dokumentation der praktischen Prüfung zum Mathematisch-technischen Softwareentwickler',
     'Roman Romany -- IEK-8 -- Prüflingsnummer 20630', 'manual'),
]


# -- Options for manual page output ------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, 'gropro', 'GroPro Documentation',
     [author], 1)
]


# -- Options for Texinfo output ----------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, 'GroPro', 'GroPro Documentation',
     author, 'GroPro', 'One line description of project.',
     'Miscellaneous'),
]


# -- Extension configuration -------------------------------------------------
